' This file has no copyright assigned and is placed in the Public Domain
' This sample reads sector zero of a USB memory stick using
' the bulk only protocol.
'
' adapted to support xhci - reads a block - works with 2.0 devices too
'
defint a-z

cls

input "Please enter sector number:" lbanumber$
lbanr???=val(ltrim$(lbanumber$))

devadd%=1
in_endpoint%=1
out_endpoint%=2

getbytes??=512 '2048 '1024 '512

maxpacketlengthctrl=512 'use for control transactions

thebufferlength=512 'either 64 or 512

'select here the paket length for the type of device
maxpacketlength=512 'ehci
'maxpacketlength=1024 'xhci

'define structure of URB
type urbtype
  transaction_token as byte 'control (2Dh), in (69h), out (E1h)
  chain_end_flag  as byte
  dev_add         as byte
  end_point       as byte
  error_code      as byte
  status          as byte  'returned by dosuhci
  transaction_flags as word 'reserved
  buffer_off      as word  'for in/out
  buffer_seg      as word  'for in/out
  buffer_length   as word  'for in/out
  actual_length   as word  'for in/out
  setup_buffer_off as word 'for control
  setup_buffer_seg as word 'for control
  start_frame     as word  'reserved
  nr_of_packets   as word  'iso
  int_interval    as byte  'reserved
  error_count     as byte  'reserved
  timeout         as word  'reserved
  next_urb_off    as word  'reserved
  next_urb_seg    as word  'reserved
end type '32 byte long

dim urb as urbtype

type setuptype
   bmRequestType  as byte
   bRequest	  as byte
   wValue	  as word
   wIndex         as word
   wLength        as word
end type

dim device_request as setuptype

type read_command  '31 byte
'first cbw fields  '15 byte
   signature      as dword
   tag            as dword
   tlength        as dword
   flags          as byte
   cbwlun         as byte
   clength        as byte
'now command fields '16 byte
   operation_code as byte
   lun            as byte
'   lba            as dword
   lbahi          as word 'bytes 2+3 (zero based)
   lbalo          as word 'bytes 4+5 (zero based)
   reserved       as byte
   blocks         as word
   controls       as byte
   padding1       as word
   padding2       as word
   padding3       as word
end type

dim read_command_request as read_command


type inquiry_command  '31 byte
'first cbw fields  '15 byte
   signature      as dword
   tag            as dword
   tlength        as dword
   flags          as byte
   cbwlun         as byte
   clength        as byte
'now command fields '16 byte
   operation_code as byte
   lun            as byte
   lba            as dword
   reserved       as byte
   blocks         as word
   controls       as byte
   padding1       as word
   padding2       as word
   padding3       as word
end type

dim inquiry_command_request as inquiry_command

dim buffer as string*10240
buffer=repeat$(10240,chr$(0)) 'return data here

dim sbuffer as string*20480
sbuffer=repeat$(20480,chr$(0)) 'return data here

'End of data structures ************************************************

'set up inquiry command incl. cbw
inquiry_command_request.signature=&H43425355
inquiry_command_request.tag=&H82A36008
inquiry_command_request.tlength=&h24
inquiry_command_request.flags=&h80
inquiry_command_request.cbwlun=0 '1
inquiry_command_request.clength=&h0C '6
'now command fields
inquiry_command_request.operation_code=&h12
inquiry_command_request.lun=0 '32 '=1
inquiry_command_request.lba=&H240000
inquiry_command_request.reserved=0
inquiry_command_request.blocks=0
inquiry_command_request.controls=0
inquiry_command_request.padding1=0
inquiry_command_request.padding2=0
inquiry_command_request.padding3=0

buffer=inquiry_command_request

'set up out request
  urb.transaction_token=&HE1
  urb.chain_end_flag=0
  urb.dev_add=devadd%
  urb.end_point=out_endpoint%
  urb.error_code=0
  urb.status=0
  urb.transaction_flags=0
  urb.buffer_off=varptr(buffer)
  urb.buffer_seg=varseg(buffer)
  urb.buffer_length=31
  urb.actual_length=maxpacketlength '31 'out
  urb.setup_buffer_off=0
  urb.setup_buffer_seg=0
  urb.start_frame=0
  urb.nr_of_packets=0
  urb.int_interval=0
  urb.error_count=0
  urb.timeout=0
  urb.next_urb_off=0
  urb.next_urb_seg=0

'now call DosUHCI
reg 8,varseg(urb)
reg 4,varptr(urb)
call interrupt &H65

buffer=repeat$(1024,chr$(0)) 'return data here

'set up in request
  urb.transaction_token=&H69
  urb.chain_end_flag=0
  urb.dev_add=devadd%
  urb.end_point=in_endpoint%
  urb.error_code=0
  urb.status=0
  urb.transaction_flags=0
  urb.buffer_off=varptr(buffer)
  urb.buffer_seg=varseg(buffer)
  urb.buffer_length=thebufferlength '512 '64
  urb.actual_length=maxpacketlength
  urb.setup_buffer_off=0
  urb.setup_buffer_seg=0
  urb.start_frame=0
  urb.nr_of_packets=0
  urb.int_interval=0
  urb.error_count=0
  urb.timeout=0
  urb.next_urb_off=0
  urb.next_urb_seg=0

'now call DosUHCI
reg 8,varseg(urb)
reg 4,varptr(urb)
call interrupt &H65

print
print "Inquiry:" left$(buffer,urb.actual_length)

'set up in request - to read CSW
  urb.transaction_token=&H69
  urb.chain_end_flag=0
  urb.dev_add=devadd%
  urb.end_point=in_endpoint%
  urb.error_code=0
  urb.status=0
  urb.transaction_flags=0
  urb.buffer_off=varptr(buffer)
  urb.buffer_seg=varseg(buffer)
  urb.buffer_length=thebufferlength '512 '64
  urb.actual_length=maxpacketlength 'ctrl
  urb.setup_buffer_off=0
  urb.setup_buffer_seg=0
  urb.start_frame=0
  urb.nr_of_packets=0
  urb.int_interval=0
  urb.error_count=0
  urb.timeout=0
  urb.next_urb_off=0
  urb.next_urb_seg=0

'now call DosUHCI
reg 8,varseg(urb)
reg 4,varptr(urb)
call interrupt &H65

print
print "CSW:" left$(buffer,urb.actual_length)

'set up request sense command incl. cbw
inquiry_command_request.signature=&H43425355
inquiry_command_request.tag=&H82A36008
inquiry_command_request.tlength=&h12
inquiry_command_request.flags=&h80
inquiry_command_request.cbwlun=0 '1
inquiry_command_request.clength=&h0C
'now command fields
inquiry_command_request.operation_code=&h03
inquiry_command_request.lun=0 '32 '=1
inquiry_command_request.lba=&H120000
inquiry_command_request.reserved=0
inquiry_command_request.blocks=0
inquiry_command_request.controls=0
inquiry_command_request.padding1=0
inquiry_command_request.padding2=0
inquiry_command_request.padding3=0

buffer=inquiry_command_request

'set up out request
  urb.transaction_token=&HE1
  urb.chain_end_flag=0
  urb.dev_add=devadd%
  urb.end_point=out_endpoint%
  urb.error_code=0
  urb.status=0
  urb.transaction_flags=0
  urb.buffer_off=varptr(buffer)
  urb.buffer_seg=varseg(buffer)
  urb.buffer_length=31
  urb.actual_length=maxpacketlength 'ctrl '31
  urb.setup_buffer_off=0
  urb.setup_buffer_seg=0
  urb.start_frame=0
  urb.nr_of_packets=0
  urb.int_interval=0
  urb.error_count=0
  urb.timeout=0
  urb.next_urb_off=0
  urb.next_urb_seg=0

'now call DosUHCI
reg 8,varseg(urb)
reg 4,varptr(urb)
call interrupt &H65

buffer=repeat$(1024,chr$(0)) 'return data here

'set up in request
  urb.transaction_token=&H69
  urb.chain_end_flag=0
  urb.dev_add=devadd%
  urb.end_point=in_endpoint%
  urb.error_code=0
  urb.status=0
  urb.transaction_flags=0
  urb.buffer_off=varptr(buffer)
  urb.buffer_seg=varseg(buffer)
  urb.buffer_length=thebufferlength '512 '64
  urb.actual_length=maxpacketlength 'ctrl
  urb.setup_buffer_off=0
  urb.setup_buffer_seg=0
  urb.start_frame=0
  urb.nr_of_packets=0
  urb.int_interval=0
  urb.error_count=0
  urb.timeout=0
  urb.next_urb_off=0
  urb.next_urb_seg=0

'now call DosUHCI
reg 8,varseg(urb)
reg 4,varptr(urb)
call interrupt &H65

print
print "Request sense:" left$(buffer,urb.actual_length)

'set up in request - to read CSW
  urb.transaction_token=&H69
  urb.chain_end_flag=0
  urb.dev_add=devadd%
  urb.end_point=in_endpoint%
  urb.error_code=0
  urb.status=0
  urb.transaction_flags=0
  urb.buffer_off=varptr(buffer)
  urb.buffer_seg=varseg(buffer)
  urb.buffer_length=thebufferlength '512 '64
  urb.actual_length=maxpacketlength 'ctrl
  urb.setup_buffer_off=0
  urb.setup_buffer_seg=0
  urb.start_frame=0
  urb.nr_of_packets=0
  urb.int_interval=0
  urb.error_count=0
  urb.timeout=0
  urb.next_urb_off=0
  urb.next_urb_seg=0

'now call DosUHCI
reg 8,varseg(urb)
reg 4,varptr(urb)
call interrupt &H65

print
print "CSW:" left$(buffer,urb.actual_length)

'set up test unit ready command incl. cbw
inquiry_command_request.signature=&H43425355
inquiry_command_request.tag=&H82A36008
inquiry_command_request.tlength=&h0
inquiry_command_request.flags=&h0
inquiry_command_request.cbwlun=0 '1
inquiry_command_request.clength=&h0C
'now command fields
inquiry_command_request.operation_code=&h00
inquiry_command_request.lun=0 '32 '=1
inquiry_command_request.lba=&H000000
inquiry_command_request.reserved=0
inquiry_command_request.blocks=0
inquiry_command_request.controls=0
inquiry_command_request.padding1=0
inquiry_command_request.padding2=0
inquiry_command_request.padding3=0

buffer=inquiry_command_request

'set up out request
  urb.transaction_token=&HE1
  urb.chain_end_flag=0
  urb.dev_add=devadd%
  urb.end_point=out_endpoint%
  urb.error_code=0
  urb.status=0
  urb.transaction_flags=0
  urb.buffer_off=varptr(buffer)
  urb.buffer_seg=varseg(buffer)
  urb.buffer_length=31
  urb.actual_length=maxpacketlength 'ctrl '31
  urb.setup_buffer_off=0
  urb.setup_buffer_seg=0
  urb.start_frame=0
  urb.nr_of_packets=0
  urb.int_interval=0
  urb.error_count=0
  urb.timeout=0
  urb.next_urb_off=0
  urb.next_urb_seg=0

'now call DosUHCI
reg 8,varseg(urb)
reg 4,varptr(urb)
call interrupt &H65

buffer=repeat$(1024,chr$(0)) 'return data here

'set up in request
  urb.transaction_token=&H69
  urb.chain_end_flag=0
  urb.dev_add=devadd%
  urb.end_point=in_endpoint%
  urb.error_code=0
  urb.status=0
  urb.transaction_flags=0
  urb.buffer_off=varptr(buffer)
  urb.buffer_seg=varseg(buffer)
  urb.buffer_length=thebufferlength '512 '64
  urb.actual_length=maxpacketlength 'ctrl
  urb.setup_buffer_off=0
  urb.setup_buffer_seg=0
  urb.start_frame=0
  urb.nr_of_packets=0
  urb.int_interval=0
  urb.error_count=0
  urb.timeout=0
  urb.next_urb_off=0
  urb.next_urb_seg=0

'now call DosUHCI
reg 8,varseg(urb)
reg 4,varptr(urb)
call interrupt &H65

print
print "Test unit ready:" left$(buffer,urb.actual_length)

'******************************************************
'needs lbanumber%

'set up bulk read command incl. cbw
read_command_request.signature=&H43425355
read_command_request.tag=&H82A36008
read_command_request.tlength=getbytes?? '&h200 '512 byte
'read_command_request.tlength=&H200 'getbytes?? '&h200 '512 byte
read_command_request.flags=&h80
read_command_request.cbwlun=0 '1
read_command_request.clength=&h0C 'A
'now command fields
read_command_request.operation_code=&h28
read_command_request.lun=0 '32 '=1

'convert lbanr??? to big endian
lbanumberlo??=lbanr??? AND &H0000FFFF
rotate right lbanumberlo??,8
shift right lbanr???,16
lbanumberhi??=lbanr???
rotate right lbanumberhi??,8
read_command_request.lbalo=lbanumberlo?? '0
read_command_request.lbahi=lbanumberhi?? '0
'print "LBAhi:" hex$(read_command_request.lbahi) " ";
'print "LBAlo:" hex$(read_command_request.lbalo) " ";

'read_command_request.lba=lbanumber% '0
'rotate right read_command_request.lba,8 'works up to lba FFh - big endian
'print "LBA:" hex$(read_command_request.lba) " ";

read_command_request.reserved=0
read_command_request.blocks=&H01 '00 'big endian
read_command_request.blocks=getbytes??/512 '&H01 '8 '00 'big endian
rotate right read_command_request.blocks,8
'print "Blocks:" hex$(read_command_request.blocks)
read_command_request.controls=0
read_command_request.padding1=0
read_command_request.padding2=0
read_command_request.padding3=0

buffer=read_command_request

'set up out request
  urb.transaction_token=&HE1
  urb.chain_end_flag=0
  urb.dev_add=devadd%
  urb.end_point=out_endpoint%
  urb.error_code=0
  urb.status=0
  urb.transaction_flags=0
  urb.buffer_off=varptr(buffer)
  urb.buffer_seg=varseg(buffer)
  urb.buffer_length=31
  urb.actual_length=maxpacketlength '31
  urb.setup_buffer_off=0
  urb.setup_buffer_seg=0
  urb.start_frame=0
  urb.nr_of_packets=0
  urb.int_interval=0
  urb.error_count=0
  urb.timeout=0
  urb.next_urb_off=0
  urb.next_urb_seg=0

'now call DosUHCI
reg 8,varseg(urb)
reg 4,varptr(urb)
call interrupt &H65

buffer=repeat$(1024,chr$(0)) 'return data here

'for i=1 to 8

'set up in request
  urb.transaction_token=&H69
  urb.chain_end_flag=0
  urb.dev_add=devadd%
  urb.end_point=in_endpoint%
  urb.error_code=0
  urb.status=0
  urb.transaction_flags=0
  urb.buffer_off=varptr(buffer)
  urb.buffer_seg=varseg(buffer)
  urb.buffer_length=getbytes?? '512 '1024 '512 '64
  urb.actual_length=maxpacketlength '64
  urb.setup_buffer_off=0
  urb.setup_buffer_seg=0
  urb.start_frame=0
  urb.nr_of_packets=0
  urb.int_interval=0
  urb.error_count=0
  urb.timeout=0
  urb.next_urb_off=0
  urb.next_urb_seg=0

'now call DosUHCI
reg 8,varseg(urb)
reg 4,varptr(urb)
call interrupt &H65

sbuffer=buffer
'mid$(sbuffer,midpos)=buffer

        'midpos=1+(i-1)*64
        'mid$(sbuffer,midpos)=buffer
'next i

'gosub do_read

if urb.error_code >0 then
        cls : locate 14,23
	print "Buffer length exceeded"
        end
end if

print
print "Sector:" left$(sbuffer,getbytes??) 'urb.actual_length)

$if 1
for i=1 to 512
'print hex$(ascii(mid$(sbuffer,i,1)));
outp$=hex$(ascii(mid$(sbuffer,i,1)))
'if len(outp$)=1 then outp$="0"+outp$
outp$=right$("0"+outp$,2)
print outp$;
next i
print
$endif

print urb.actual_length
print


$if 0
if lbanumber%=0 then
   print
   print "Partition table: "
   print "AF SH SC SS PT EH EC ES Start       Length"
   for i=&H1BF to 512 'urb.actual_length
       print right$("0"+hex$(ascii(mid$(sbuffer,i,1))),2) " ";
       if (i-&H1BE) mod 16 = 0 then print
   next i
end if

print
print "Active flag:" hex$(ascii(mid$(sbuffer,&H1BF,1)));
print " - Partition type:" hex$(ascii(mid$(sbuffer,(&H1BF+4),1)));
print " - Partition start sector:" hex$(ascii(mid$(sbuffer,(&H1BF+&H08),1)));
print "h =" ascii(mid$(sbuffer,(&H1BF+&H08),1))
myvalue???=0
myvalue???=myvalue???+ascii(mid$(sbuffer,(&H1BF+&H0F),1))
shift left myvalue???,8
myvalue???=myvalue???+ascii(mid$(sbuffer,(&H1BF+&H0E),1))
shift left myvalue???,8
myvalue???=myvalue???+ascii(mid$(sbuffer,(&H1BF+&H0D),1))
shift left myvalue???,8
myvalue???=myvalue???+ascii(mid$(sbuffer,(&H1BF+&H0C),1))
print "Partition length in sectors:";
print using "###,###,###,###,###"; myvalue???
print "Partition length in bytes (if 512 bytes/sector):";
print using "###,###,###,###,###,###"; myvalue???*512
$endif


'set up in request - to read CSW
  urb.transaction_token=&H69
  urb.chain_end_flag=0
  urb.dev_add=devadd%
  urb.end_point=in_endpoint%
  urb.error_code=0
  urb.status=0
  urb.transaction_flags=0
  urb.buffer_off=varptr(buffer)
  urb.buffer_seg=varseg(buffer)
  urb.buffer_length=thebufferlength '512 '64
  urb.actual_length=maxpacketlength 'ctrl
  urb.setup_buffer_off=0
  urb.setup_buffer_seg=0
  urb.start_frame=0
  urb.nr_of_packets=0
  urb.int_interval=0
  urb.error_count=0
  urb.timeout=0
  urb.next_urb_off=0
  urb.next_urb_seg=0

'now call DosUHCI
reg 8,varseg(urb)
reg 4,varptr(urb)
call interrupt &H65

print
print "CSW:" left$(buffer,urb.actual_length)

end

$if 0

do_read:  'needs lbanumber%
'set up bulk read command incl. cbw
read_command_request.signature=&H43425355
read_command_request.tag=&H82A36008
read_command_request.tlength=&h200 '512 byte
read_command_request.flags=&h80
read_command_request.cbwlun=0 '1
read_command_request.clength=&h0C 'A
'now command fields
read_command_request.operation_code=&h28
read_command_request.lun=0 '32 '=1
read_command_request.lba=lbanumber% '0
rotate right read_command_request.lba,8 'works up to lba FFh - big endian
'print "LBA:" hex$(read_command_request.lba) " ";
read_command_request.reserved=0
read_command_request.blocks=&H01 '00 'big endian
rotate right read_command_request.blocks,8
'print "Blocks:" hex$(read_command_request.blocks)
read_command_request.controls=0
read_command_request.padding1=0
read_command_request.padding2=0
read_command_request.padding3=0

'mid$(buffer,1,64)=read_command_request
buffer=read_command_request

'set up out request
  urb.transaction_token=&HE1
  urb.chain_end_flag=0
  urb.dev_add=devadd%
  urb.end_point=out_endpoint%
  urb.error_code=0
  urb.status=0
  urb.transaction_flags=0
  urb.buffer_off=varptr(buffer)
  urb.buffer_seg=varseg(buffer)
  urb.buffer_length=31
  urb.actual_length=maxpacketlength '31
  urb.setup_buffer_off=0
  urb.setup_buffer_seg=0
  urb.start_frame=0
  urb.nr_of_packets=0
  urb.int_interval=0
  urb.error_count=0
  urb.timeout=0
  urb.next_urb_off=0
  urb.next_urb_seg=0

'now call DosUHCI
reg 8,varseg(urb)
reg 4,varptr(urb)
call interrupt &H65

buffer=repeat$(1024,chr$(0)) 'return data here

i=0
'm=512/maxpacketlength
'while i<1 '2 'maxpacketlength 'leave if 8 ( 8*64=512 )
while i<8 '2 'maxpacketlength 'leave if 8 ( 8*64=512 )
'set up in request
  urb.transaction_token=&H69
  urb.chain_end_flag=0
  urb.dev_add=devadd%
  urb.end_point=in_endpoint%
  urb.error_code=0
  urb.status=0
  urb.transaction_flags=0
  urb.buffer_off=varptr(buffer)
  urb.buffer_seg=varseg(buffer)
  urb.buffer_length=512 '1024 '512 '64
  urb.actual_length=maxpacketlength '64
  urb.setup_buffer_off=0
  urb.setup_buffer_seg=0
  urb.start_frame=0
  urb.nr_of_packets=0
  urb.int_interval=0
  urb.error_count=0
  urb.timeout=0
  urb.next_urb_off=0
  urb.next_urb_seg=0

'now call DosUHCI
reg 8,varseg(urb)
reg 4,varptr(urb)
call interrupt &H65

'if urb.status=0 then
	incr i
        midpos=1+(i-1)*64
        mid$(sbuffer,midpos)=buffer
'elseif urb.status<>88 then
'	exit loop
'end if
'do not incr if 88

wend

return

$endif
